ABSTRACT
------------

The RoboCup Small Size Soccer League (SSL) is a worldwide known Robotics competition. The competition often requires the teams to solve path planning problems. In order to find global planning solutions for this system, the teams often use two ideas. The first idea is to decouple the path planning and tracking problems. Path tracking is a technique used so that the robot follows planned paths. Initially, considering an approach purely kinematic, we tested famous path planners found in the literature, such as RRT (\textit{Rapidly Exploring Random Trees}), ERRT (Extended Execution Rapidly Exploring Random Trees), RRT*,  FMT* (Fast Marching Trees), and BIT* (Batch Informed Trees). To the best of our knowledge, the last two were never used in the SSL, as opposed to RRT and its variants. The planners' BIT and FMT had a good performance when comparing sampling-based approaches. A second idea incorporates the system's dynamic constraints in the high-level, executing a global kinodynamic planning.
The framework used to construct a kinodynamic planner initially required the development of a boundary value problem (BVP) solver to connect different state space states with dynamically feasible trajectories. In the literature,  we found motion planners for an equivalent problem, but for environments without obstacles, where the robot has to arrive at a given state with zero velocity. We extended the applicability of this solution for more states of the state space by adapting the synchronization algorithm. We analyzed the problem, reaching mathematical conclusions. With these conclusions, the solution to the problem was successfully extended, and we showed examples of applications. Furthermore, we adapted RRT* and FMT* to use the constructed BVP solver at the lower level to build kinodynamic planners. The best kinematic path planner tested, BIT*, took an average convergence time of 3 ms, having 100% of success probability over the SSL field. The best kinodynamic planner tested (RRT* based)  had an average convergence time of 0.8 seconds, reaching up to 90\% of success probability over the field. The results indicate that there is still room for improvement in the kinodynamic planners, especially when it comes to planning time and convergence properties. Other ideas could be tested in the future, such as using reinforcement learning tools to build the low-level motion planner and testing other global planning algorithms that reduce the planning time.

DATA MANAGEMENT
------------


The repository is divided in 3 folders: binaries with the binaries, scripts with the MATLAB files, and simulator with the core C++ code.

The of the dissertation is mainly generated by component tests (simulator/tests/component). The component tests were split into several folders:

bvp_solver -> performs tests to see sine and cosine optimizations
kinodynamic_planners_performance -> tests corresponding to the Kinodynamic planning chapter. The data is generated in .txt files, that are processed in MATLAB (further explained)
path_planning -> tests corresponding to the path planners comparing chapter. Again, the data is saved into .txt files to be after processed.
tracking -> tests corresponding to the path planners comparing chapter, specifically about tracking tests.

The other folders, although important, are not included in the scope of the dissertation.


DATA PROCESSING
------------

The data processing is entirely done in MATLAB (scripts/matlab). The data was distributed accross diferent folders:

analysis_result -> contains scripts to process data of the path planning comparison chapter.
analyze_kinodynamic_planning -> contains scripts to process data of the kinodynamic path planning chapter.
bvpSolver -> contains scripts to analyze the boundary value problem solver developed in the dissertation. The scripts contained in this folder generated the figures of the boundary problem solver chapter.
